import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:path_stack/path_stack.dart';

class HelloWorldExample extends StatefulWidget {
  @override
  _HelloWorldExampleState createState() => _HelloWorldExampleState();
}

class _HelloWorldExampleState extends State<HelloWorldExample> {
  String path = "page1";

  @override
  void initState() {
    RawKeyboard.instance.addListener((value) {
      if (value is RawKeyDownEvent) {
        final k = value.logicalKey;
        if (k == LogicalKeyboardKey.digit1) setState(() => path = "page1");
        if (k == LogicalKeyboardKey.digit2) setState(() => path = "page2");
        if (k == LogicalKeyboardKey.digit3) setState(() => path = "page3/");
        if (k == LogicalKeyboardKey.digit4) setState(() => path = "page3/subPage1");
        if (k == LogicalKeyboardKey.digit5) setState(() => path = "page3/subPage2");
      }
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return PathStack(
      path: path,
      routes: {
        ["page1"]: (_) => Container(color: Colors.red),
        ["page2"]: (_) => Container(color: Colors.red),
        ["page3/"]: (_) => PathStack(
              routes: {
                //matches: /page3/subPage1 or /page3/
                ["subPage1", ""]: (_) => Container(color: Colors.orange),
                //matches: only /page3/subPage2
                ["subPage2"]: (_) => Container(color: Colors.purple),
              },
            ),
      },
    );
  }
}
