import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:path_stack/path_stack.dart';

import 'simple_tab_example_pages.dart';

/// 3 top-level routes with a shared tab menu, all mapped to an enum value.
/// This is a tabbed app with 3 main sections, in about 10 lines :)

enum PageType { Home, Explore, Settings }

class SimpleTabExample extends StatefulWidget {
  @override
  _SimpleTabExampleState createState() => _SimpleTabExampleState();
}

class _SimpleTabExampleState extends State<SimpleTabExample> {
  PageType _currentPage = PageType.Home;
  @override
  Widget build(BuildContext context) {
    String currentPath = describeEnum(_currentPage);
    return PathStack(
      path: currentPath,
      transitionBuilder: (_, stack, anim) => FadeTransition(opacity: anim, child: stack),
      scaffoldBuilder: (_, stack) => TabScaffold(_currentPage, child: stack, onTabPressed: _handleTabPressed),
      routes: {
        ["${describeEnum(PageType.Home)}"]: (_) => HomePage(),
        ["${describeEnum(PageType.Settings)}"]: (_) => SettingsPage(),
        ["${describeEnum(PageType.Explore)}"]: (_) => RouteConfig(maintainState: false, child: ExplorePage()),
      },
    );
  }

  // Change page type and rebuild the parent view
  void _handleTabPressed(PageType value) => setState(() => _currentPage = value);
}
