import 'package:flutter/material.dart';
import 'package:path_stack/path_stack.dart';


/// Defines how a Route should act
class RouteConfig extends StatelessWidget {
  const RouteConfig({
    Key? key,
    required this.child,
    this.maintainState = true,
    this.exactMatch,
    this.onBeforeEnter,
  }) : super(key: key);

  final Widget child;
  final bool maintainState;
  final bool? exactMatch;
  final bool Function(String newRoute)? onBeforeEnter;

  @override
  Widget build(BuildContext context) => child;
}

typedef PathStackRouteBuilder = Widget Function(PathStackState stack);
